var A=1,B=60,O=3600,z=86400,L=604800,g=class n{constructor(e,t=1){this.rate=e;this.size=t;if(e<=0)throw"rate must be greater than 0";if(t<1)throw"size must be at least 1"}static parse(e){let r=/(?<rate>\d+)\s*\/\s*(?<unit>second|minute|hour|day|week)\s*(,\s*(?<size>\d+))?/gi.exec(e);if(!r)throw"unable to parse refill value "+e;let o=parseInt(r.groups.rate),s=n.unitToDenominator(r.groups.unit.toLowerCase()),i=parseInt(r.groups.size??"1");return new n(o/s,i)}static unitToDenominator(e){switch(e){case"second":return 1;case"minute":return 60;case"hour":return 3600;case"day":return 86400;case"week":return 604800;default:throw"unexpected unit"}}};var p=class{apply(e,t,r,o){let s=e.size-o,i=Math.floor(o),a=Math.max(t-o,0),c=a>0?Math.ceil(a/e.rate):0,m=`${e.size};w=${e.rate}`;return{allowed:r,limit:s,remaining:i,reset:c,policy:m}}};var k=class extends p{buckets=new Map;async consume(e,t,r=1){let o=Date.now(),s=this.buckets.get(e);s||(s={tokens:t.size,updated:o},this.buckets.set(e,s));let a=(o-s.updated)*t.rate/1e3;s.tokens=Math.min(t.size,s.tokens+a),s.updated=o;let c=s.tokens>=r;return c&&(s.tokens-=r),this.apply(t,r,c,s.tokens)}};import"redis";var x=class n extends p{constructor(t,r="bucket:",o="TokenBucket",s="consume"){super();this.redis=t;this.prefix=r;this.module=o;this.fname=s}async consume(t,r,o=1){let s=await this.redis.sendCommand(["TFCALL",`${this.module}.${this.fname}`,"0",this.prefix+t,r.size.toString(),r.rate.toString(),o.toString()]),i=!1,a=0;for(let c=0;c<s.length;c+=2){let m=s[c],f=s[c+1];switch(m){case"allowed":i=f===1;break;case"tokens":a=parseFloat(f);break}}return this.apply(r,o,i,a)}static async create(t,r="bucket:",o="TokenBucket",s="consume"){let i=`#!js name=${o} api_version=1.0
redis.registerFunction('${s}', (client, key, size, rate, count) => {
	const now = Date.now()

	let bucket = client.call('hgetall', key)
	if (bucket.updated) {
		const deltaMs = now - parseInt(bucket.updated)
		const deltaNo = deltaMs * rate / 1000

		bucket.tokens = Math.min(size, parseFloat(bucket.tokens) + deltaNo)
		bucket.updated = now
	} else {
		bucket = { tokens: size, updated: now }
	}

	const allowed = bucket.tokens >= count
	if (allowed) {
		bucket.tokens -= count
	}

	// calculate how many tokens, or fractions of a token, are needed for the bucket to be full
	const deltaNo = Math.max(size - bucket.tokens, 0)

	// calculate time until the bucket is full, based on refill rate
	const expire = deltaNo > 0 ? Math.ceil(deltaNo / rate) : 0

	client.call('hset', key, 'tokens', bucket.tokens.toString(), 'updated', bucket.updated.toString())
	client.call('expire', key, expire.toString())

	return {
		allowed,
		tokens: bucket.tokens,
	}
})`;return await t.sendCommand(["TFUNCTION","LOAD","REPLACE",i]),new n(t,r,o,s)}};var u=class{constructor(e,t){this.status=e,typeof t=="string"?this.body={message:t}:t?this.body=t:this.body={message:`Error: ${e}`}}toString(){return JSON.stringify(this.body)}};function l(n,e){throw(!!1||!1)&&(isNaN(n)||n<400||n>599)?new Error(`HTTP error status codes must be between 400 and 599 \u2014 ${n} is invalid`):new u(n,e)}var pe=new TextEncoder;var w=class{constructor(e,t,r){this.extractor=e;this.manager=t;this.bucket=r}handle=async e=>{let{event:t,resolve:r}=e,{locals:o}=t,s=await this.extractor.extract(t),i=await this.manager.validate(s);return o.api=new h(t,this.bucket,s,i),await r(t)}},h=class{constructor(e,t,r,o){this.event=e;this.bucket=t;this.key=r;this.info=o}_name="";_cost=1;_anon=!1;_has="";_any=[];_all=[];anonymous(){return this._anon=!0,this}name(e){return this._name=e,this}cost(e){return e<1&&l(500,"API cost must be at least 1"),this._cost=e,this}has(e){return this._has=e,this}any(e){return this._any=e,this}all(e){return this._all=e,this}async approve(e){let{key:t,info:r}=this;if(!this._anon&&!t&&l(401,"Missing API Key"),t&&!this.info&&l(403,"Invalid API Key"),r){if(r.expires&&r.expires.getTime()<Date.now()&&l(403,"API Key Expired"),this._has.length&&!r.permissions.includes(this._has)&&l(403,"Missing Permission: "+this._has),this._all.length&&!this._all.every(i=>r.permissions.includes(i))){let i=this._all.filter(a=>!r.permissions.includes(a)).join(", ");l(403,"Missing Permissions: "+i)}if(this._any.length&&!this._any.some(i=>r.permissions.includes(i))){let i=this._any.join(", ");l(403,"Missing any Permission: "+i)}}let o=(t||this.event.getClientAddress())+":"+this._name,s=await this.bucket.consume(o,e,this._cost);return this.event.setHeaders({"RateLimit-Limit":s.limit.toString(),"RateLimit-Remaining":s.remaining.toString(),"RateLimit-Reset":s.reset.toString(),"RateLimit-Policy":s.policy}),s.allowed||l(429,"Too Many Requests"),s}};var b=class{constructor(e){this.options=e}async extract(e){let t=null,r=e.request.clone();return this.options.cookie&&(t=e.cookies.get(this.options.cookie)??null),this.options.httpHeader&&(t=r.headers.get(this.options.httpHeader)||t),this.options.searchParam&&(t=e.url.searchParams.get(this.options.searchParam)||t),this.options.custom&&(t=await this.options.custom(e,t)),t}};import{randomBytes as K,createHash as F}from"crypto";import N from"base-x";import P from"bad-words-next";import T from"bad-words-next/data/en.json";var D="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",d=N(D),H=new P({data:T}),v=class{constructor(e,t=32){this.storage=e;this.key_length=t}hashFromBytes(e){return F("sha256").update(e).digest("hex")}async generate(e){let t,r;do r=K(this.key_length),t=d.encode(r);while(H.check(t));let o=this.hashFromBytes(r);return await this.storage.put(o,e),t}async validate(e){if(!e)return null;let t=d.decode(e),r=this.hashFromBytes(t);return await this.storage.get(r)}async remove(e){let t=d.decode(e),r=this.hashFromBytes(t);return await this.storage.del(r)}async retrieve(e){return await this.storage.list(e)}};var _={toFirestore:n=>n,fromFirestore:n=>{let e=n.data(),t=e.expires?e.expires.toDate():null;return{...e,expires:t}}},R=class{constructor(e,t="api"){this.firestore=e;this.name=t;this.collection=this.firestore.collection(this.name).withConverter(_)}collection;async put(e,t){await this.collection.doc(e).set(t)}async get(e){return(await this.collection.doc(e).get()).data()||null}async del(e){await this.collection.doc(e).delete()}async list(e){return(await this.collection.where("user","==",e).get()).docs.map(r=>r.data())}};var E=class{keys=new Map;async put(e,t){this.keys.set(e,t)}async get(e){return this.keys.get(e)??null}async del(e){this.keys.delete(e)}async list(e){return Array.from(this.keys.values()).filter(r=>r.user===e)}};import{ErrorReply as M,SchemaFieldTypes as y}from"redis";var S=class n{constructor(e,t){this.redis=e;this.prefix=t}static async create(e,t="api:"){try{await e.ft.info(t+"index")}catch(r){if(r instanceof M&&r.message==="Unknown index name")await e.ft.create(t+"index",{user:y.TAG,permissions:y.TAG,expires:y.NUMERIC},{ON:"HASH",PREFIX:t});else throw r}return new n(e,t)}async put(e,t){await this.redis.hSet(this.prefix+e,{user:t.user,name:t.name,description:t.description,permissions:t.permissions.join(","),...t.expires?{expires:t.expires.getTime()/1e3}:{}})}async get(e){let t=await this.redis.hGetAll(this.prefix+e);return t.name===null?null:{user:t.user,name:t.name,description:t.description,permissions:t.permissions.split(","),expires:t.expires?new Date(parseFloat(t.expires)*1e3):null}}async del(e){await this.redis.del(this.prefix+e)}async list(e){let t=/[,.?<>{}[\]"':;!@#$%^&()\-+=~|/\\ ]/g,r=e.replace(t,"\\$&");return(await this.redis.ft.search(this.prefix+"index",`@user:{${r}}`)).documents.map(i=>{let a=i.value;return{user:a.user,name:a.name,description:a.description,permissions:a.permissions.split(","),expires:a.expires?new Date(parseFloat(a.expires)*1e3):null}})}};export{h as Api,z as DAY,R as FirestoreKeyStore,O as HOUR,w as Handler,E as InMemoryKeyStore,k as InMemoryTokenBucket,b as KeyExtractor,v as KeyManager,B as MINUTE,S as RedisKeyStore,x as RedisTokenBucket,g as Refill,A as SECOND,p as TokenBucket,L as WEEK};
